#!/usr/bin/perl
# delete.cgi
# Delete a post, including colateral data

use warnings ;
use strict ;
use DB_File ;

require "session.pl";

## DECLARATIONS
our $dbdir;
require "../conf.pl"; #get $dbdir value from ../conf.pl
$dbdir = "../".$dbdir; #fix $dbdir

my $cnt=0 ; # wild-card counter
my @list;
my $id ;
my $cadena ;
my ($name, $value);

# test $ENV{'QUERY_STRING'}
if( length($ENV{'QUERY_STRING'})!=21 || index($ENV{'QUERY_STRING'},"id")!=0 ) { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error0, with input data: ".$ENV{'QUERY_STRING'}."</p></body></html>"; exit 0;}

# CHECK AUTHENTICATION
my @pairs = split(/&/, $ENV{'QUERY_STRING'}); # separating variables
($name, $value) = split(/=/, $pairs[0]);
if($name ne "id") { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error2, with input data: ".$ENV{'QUERY_STRING'}."</p></body></html>"; exit 0;}
$id=$value;


## OPENING DATABASES

sub Compare { my ($key1,$key2)=@_; "\L$key2" cmp "\L$key1"; } # getting first the last post
$DB_BTREE->{'compare'} = \&Compare ; # specify the Perl sub that will do the comparison

my %titles ; # to handle titles DB
tie %titles, "DB_File", $dbdir."habla_titles.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'titles': $!\n" ; # error :(
my %texts ; # to handle texts DB
tie %texts, "DB_File", $dbdir."habla_texts.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'texts': $!\n" ; # error :(

$DB_BTREE->{'flags'} = R_DUP ; # permit duplication in next DB's
my ($id_tag, %id_tag); # to handle id -> tag DB
$id_tag = tie %id_tag, "DB_File", $dbdir."habla_id_tag.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file id_tag: $!\n" ; # error :(
my ($tag_id, %tag_id); # to handle tag -> id DB
$tag_id = tie %tag_id, "DB_File", $dbdir."habla_tag_id.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file tag_id: $!\n" ; # error :(

my %comments ; # to handle COMMENTS DB
my $comments = tie %comments, "DB_File", $dbdir."habla_comments.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'comments': $!\n" ; # error :(

my (@numid, $numid); # to handle number -> id RECNO DB
$numid = tie @numid, "DB_File", $dbdir."habla_numid.db", O_RDWR|O_CREAT, 0666, $DB_RECNO # opendb, if it does not exist create
	or die "Cannot open file 'numid': $!\n" ; # error :(


### CREATING HTML # http server head
print "Content-type: text/html; charset=utf-8\n\n
<html><head><title>Perl and BDB example script</title>
</head><body>";

# Delete in habla_titles.db
$cadena = $titles{$id};
if (delete $titles{$id}==0) { print "<p>Title deleted: $cadena</p>\n" ;}

# Delete in habla_texts.db
$cadena = $texts{$id};
if (delete $texts{$id}==0) { print "<p>Text deleted: $cadena</p>\n" ;} 

# Delete in habla_commets.db
@list = $id_tag->get_dup($id); # get a list of comments
foreach (@list){
	$cadena = $_;
	if($comments->del_dup($id,$_)==0) {print "<p>Comments deleted: $cadena</p>\n" ;}
}

# Delete in habla_tag_id.db
@list = $id_tag->get_dup($id); # get a list of tags
foreach (@list){
	$cadena = $_;
	if($tag_id->del_dup($_,$id)==0) {print "<p>Tag deleted: $cadena to ID</p>\n" ;}
	if($id_tag->del_dup($id,$_)==0) {print "<p>ID to $cadena Tag deleted</p>\n" ;}
} # delete each {tag,id}

# Delete in habla_numid.db "dirty code"
for (my $i = 0; $i < $numid->length; $i++){
	if($numid[$i]==$id) {
		if($numid->del($i)==0){print "<p>Index $i to $id deleted</p>\n" ;}
	}
}

### CLOSING DATABASES

untie %titles ; #closing db's
untie %texts ;
undef $id_tag ; untie %id_tag ;
undef $tag_id ; untie %tag_id ;
undef $comments ; untie %comments ;
undef $numid ; untie @numid ;

print "\n<br/>\nID $id deleted
<br/>Go to <a href=\"panel_manage.cgi\">Panel</a><br/>
</body></html>\n";

1; # Correct finish with 1